
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/



#include "StdAfx.h"
#include "Application.h"
#include "Workbook.h"
#include <autowrap.h>

/*
	CWorkbook class Represents a Microsoft Excel workbook by using OpenOffice.
	It implements IWorkbook COM interface.
*/
CWorkbook::CWorkbook():
    m_Sheets(this)
{
	WRITE_LOG_R_W((L"CWorkbook::CWorkbook"));
}

CWorkbook::~CWorkbook()
{
	WRITE_LOG_R_W((L"CWorkbook::~CWorkbook"));
}

HRESULT CWorkbook::Initialize(CApplication  *pApp)
{
	WRITE_LOG_R_W((L"CWorkbook::Initialize1"));
    // External AddWorkbook
	m_pThisApp = pApp;
	//pApp->AddRef(); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CComVariant resultDoc;

	CComVariant parm[4]; 
	VariantInit(&parm[0]); 
	parm[0] = L"private:factory/scalc"; // Type of created document
	parm[1] = L"_blank";  // Template
	parm[2] = 1;  // Another params count

	CComVariant res;	
	IDispatch *dpv = NULL;
    CComVariant p1 (L"Hidden");
    HRESULT hres;
    //if (!CApplication::s_bShowed)
    //{
	   // m_pThisApp->GetDispatchPropertyValue(&dpv);
    //	

	   // hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Name", 1, p1);
	   // if (FAILED (hres)) 
	   // {
		  //  dpv->Release();
		  //  return hres;
	   // }
	   // VARIANT pp;
	   // VariantInit (&pp);
	   // pp.vt = VT_BOOL;
	   // pp.boolVal = (VARIANT_TRUE);
	   // hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Value", 1, pp);
	   // if (FAILED(hres)) 
	   // {
		  //  dpv->Release();
    //		
		  //  return hres;
	   // }

	   // SAFEARRAY FAR* pPropVals = SafeArrayCreateVector( VT_DISPATCH, 0, 1 );
	   // long ix = 0; 
	   // hres = SafeArrayPutElement( pPropVals, &ix, dpv ); 
	   // if (FAILED (hres)) 
	   // {
		  //  dpv->Release();
    //		
		  //  return hres;
	   // }
	   // VariantInit(&parm[3]); 
    //	parm[3].vt = VT_DISPATCH | VT_ARRAY;
    //	parm[3].parray = pPropVals;
    //} else
    //{
    //    parm[3].vt = VT_VARIANT | VT_ARRAY;
    //    parm[3].parray = NULL;
    //}    

    parm[3].vt = VT_VARIANT | VT_ARRAY;
    parm[3].parray = NULL;

    hres = AutoWrap(DISPATCH_METHOD, 
        &resultDoc, 
        m_pThisApp->CApplication::s_pdDesktop, 
        L"loadComponentFromURL", 
        4, parm[3], parm[2], parm[1], parm[0]); 
	if (FAILED (hres))
	{
		dpv->Release();
		m_pThisApp->Release();
		return hres;
	}

	m_pdDoc = resultDoc.pdispVal; 

    if (dpv != NULL)
    {
	    dpv->Release();
    }
	hres = m_Sheets.Initialize(this);

    return hres;
}

HRESULT CWorkbook::Initialize(CApplication  *pApp, CComVariant vFileName)
{
	WRITE_LOG_R_W((L"CWorkbook::Initialize2"));
	if ((pApp == NULL) || (pApp->CApplication::s_pdDesktop == NULL))
	{
		return E_FAIL;
	}
    // External AddWorkbook
	m_pThisApp = pApp;
	//pApp->AddRef(); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	HRESULT hres;
	CComVariant res;	
	CComVariant ResultDoc;
	CComVariant params[4]; 
	params[0] = vFileName;		// Type of created document
	params[1] = L"_blank";		// Template
	params[2] = 1;				// Another params count
  //  if (!CApplication::s_bShowed)
  //  {
		//IDispatch *dpv = NULL;
		//CComVariant p1 (L"Hidden");
	 //   m_pThisApp->GetDispatchPropertyValue(&dpv);
  //  	

	 //   hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Name", 1, p1);
	 //   if (FAILED (hres)) 
	 //   {
  //          WRITE_LOG_R_W((L"FILED"));
		//    dpv->Release();
		//    return hres;
	 //   }
	 //   VARIANT pp;
	 //   VariantInit (&pp);
	 //   pp.vt = VT_BOOL;
	 //   pp.boolVal = (VARIANT_TRUE);
	 //   hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Value", 1, pp);
	 //   if (FAILED (hres)) 
	 //   {
  //          WRITE_LOG_R_W((L"FILED"));
		//    dpv->Release();
		//    return hres;
	 //   }

	 //   SAFEARRAY FAR* pPropVals = SafeArrayCreateVector( VT_DISPATCH, 0, 1 );
	 //   long ix = 0; 
	 //   hres = SafeArrayPutElement( pPropVals, &ix, dpv ); 
	 //   if (FAILED (hres)) 
	 //   {
  //          WRITE_LOG_R_W((L"FILED"));
		//    dpv->Release();
		//    return hres;
	 //   }
	 //   VariantInit(&params[3]); 
  //  	params[3].vt = VT_DISPATCH | VT_ARRAY;
  //  	params[3].parray = pPropVals;
  //  } else
  //  {
	 //   params[3].vt = VT_VARIANT | VT_ARRAY;
	 //   params[3].parray = NULL;
  //  }    

    params[3].vt = VT_VARIANT | VT_ARRAY;
    params[3].parray = NULL;

	hres = AutoWrap (DISPATCH_METHOD, &ResultDoc, m_pThisApp->CApplication::s_pdDesktop, L"loadComponentFromURL", 4, params[3], params[2], params[1], params[0]); 
	if (hres != S_OK)
	{
		m_pThisApp->Release();
		return hres;
	}
	m_pdDoc  = ResultDoc.pdispVal; 

	hres = m_Sheets.Initialize(this);

    return hres;
}

STDMETHODIMP CWorkbook::get_Sheets(ISheets **ppSheets)
{
    WRITE_LOG_R_W((L"CWorkbook::get_Sheets(...)"));

    if (ppSheets == NULL)
    {
        return E_POINTER;
    }
    *ppSheets = &m_Sheets;
    m_Sheets.AddRef();
    return S_OK;
}

STDMETHODIMP CWorkbook::get_Worksheets(ISheets** ppSheets)
{
    WRITE_LOG_A(("CWorkbook::get_Worksheets(...)"));
    return get_Sheets(ppSheets);
}

void CWorkbook::Close(std::wstring pFilename)
{
	WRITE_LOG_R_W((L"CWorkbook::Close"));	
	CComVariant res;	
    if (pFilename == L"")
    {
	    AutoWrap(DISPATCH_METHOD, &res, m_pdDoc, L"Dispose", 0);
        return ;
    }
	// Create PropertyValue with save-format-data
	IDispatch *dpv;
	m_pThisApp->GetDispatchPropertyValue(&dpv); 
	if (dpv == NULL)
    {
		return;
    }
	// Set PropertyValue data
	CComVariant p1 (L"FilterName");
	AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Name", 1, p1);
	p1 = L"MS Excel 97";
	AutoWrap(DISPATCH_PROPERTYPUT, &res, dpv, L"Value", 1, p1);

	// Init params
	SAFEARRAY FAR* pPropVals = SafeArrayCreateVector( VT_DISPATCH, 0, 1 );
	long ix = 0; 
	HRESULT hres = SafeArrayPutElement( pPropVals, &ix, dpv ); 
	VARIANT p3;
	VariantInit (&p3);
	p3.vt = VT_DISPATCH|VT_ARRAY;
	p3.parray = pPropVals;

	p1 = pFilename.c_str();	
	// Call StoreToURL for save document to file
    AutoWrap(DISPATCH_METHOD, &res, m_pdDoc, L"StoreToURL", 2, p3, p1);
	
    AutoWrap(DISPATCH_METHOD, &res, m_pdDoc, L"Dispose", 0);
	dpv->Release ();
}

CComPtr<IDispatch> CWorkbook::getOODocument() const
{
    return m_pdDoc;
}
