/***************************************************************************
* This module is part of the Excel COM cloner
* Copyright (c) Applianz, Inc. 2004
* All Rights Reserved.
* This document contains unpublished, confidential and proprietary 
* information of Applianz, Inc. No disclosure or use of 
* any portion of the contents of these materials may be made without the 
* express written consent of Applianz, Inc.
* 
* File name:       InternalObject.h
*
* Creation date:   27.10.2004
*
* Author(s):       Andrew Lyakhov, Vladimir Bayda
*
* Description:     This file contains declaration of the class CComInternalObject
*				   which is wrapper for some declared classes.
*
* Functions:       class CComInternalObject;
*
*****************************************************************************/
#pragma once

template <class Base> // Base must be derived from CComObjectRoot
class CComInternalObject : public Base
{
public:
    CComInternalObject(IUnknown *pUnk) 
    {
        m_pOuterUnknown = pUnk;
    }

    STDMETHOD_(ULONG, AddRef)() 
    {
        return OuterAddRef();
    }

    STDMETHOD_(ULONG, Release)() 
    {
        return OuterRelease();
    }

    STDMETHOD(QueryInterface)(REFIID iid, void **ppvObject)
    {
        return _InternalQueryInterface(iid, ppvObject);
    }

    template <class Q>
    HRESULT STDMETHODCALLTYPE QueryInterface(Q **pp)
    {
        return QueryInterface(__uuidof(Q), (void**)pp);
    }
};
