/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#include "Log.h"

#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

char     CLog::s_pszLogFileName[_MAX_PATH];

// SetFileName method sets name and location of the log file.
void CLog::SetFileName(char *pszFileName)
{
    if (pszFileName != NULL)
    {
        strcpy(CLog::s_pszLogFileName, pszFileName);
    }
}



// PrintW method writes log message in ASCII. The message may 
// contains formatting information as specified for the prinf function.
int CLog::PrintA(const char *fmt, ...)
{
    static FILE *pFile = NULL;
    if ((pFile == NULL)/* || (::IsBadReadPtr((LPCVOID) pFile, sizeof(pFile)))*/)
    {
        pFile = fopen(s_pszLogFileName, "a");
        if (pFile == NULL)
        {
            return 1;
        }
    }

    va_list argptr;
    va_start(argptr, fmt);
    int res =  vfprintf(pFile, fmt, argptr);
    va_end(argptr);
    
    fprintf(pFile, "\n");
    fflush(pFile);

    return 0;
}

// PrintW method writes log message in UNICODE. The message may 
// contains formatting information as specified for the prinf function.
int CLog::PrintW(const wchar_t *fmt,...)
{
    static FILE *pFile = NULL;
    if ((pFile == NULL)/* || (::IsBadReadPtr((LPCVOID) pFile, sizeof(pFile)))*/)
    {
        pFile = fopen(s_pszLogFileName, "a");
        if (pFile == NULL)
        {
            return 1;
        }
    }

    va_list argptr;
    va_start(argptr, fmt);
    vfwprintf(pFile, fmt, argptr);
    va_end(argptr);
    
    fprintf(pFile, "\n");
    fflush(pFile);

    return 0;
}
